VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   6270
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   10305
   LinkTopic       =   "Form1"
   ScaleHeight     =   6270
   ScaleWidth      =   10305
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   9120
      TabIndex        =   14
      Top             =   4500
      Width           =   915
   End
   Begin VB.Frame Frame1 
      Height          =   975
      Left            =   6720
      TabIndex        =   10
      Top             =   3900
      Width           =   2235
      Begin VB.OptionButton optNoMark 
         Caption         =   "Don't Mark"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   660
         Width           =   1275
      End
      Begin VB.OptionButton optMarkMatches 
         Caption         =   "Mark Matches"
         Height          =   195
         Left            =   120
         TabIndex        =   12
         Top             =   420
         Width           =   1875
      End
      Begin VB.OptionButton optMarkChanges 
         Caption         =   "Mark Changes"
         Height          =   195
         Left            =   120
         TabIndex        =   11
         Top             =   180
         Value           =   -1  'True
         Width           =   1695
      End
   End
   Begin VB.CommandButton cmdBenchmark 
      Caption         =   "Benchmark"
      Height          =   435
      Left            =   5160
      TabIndex        =   8
      Top             =   4440
      Width           =   1515
   End
   Begin VB.CheckBox chkGrid 
      Caption         =   "Show Spot Grid"
      Height          =   495
      Left            =   9000
      TabIndex        =   7
      Top             =   3960
      Width           =   975
   End
   Begin VB.HScrollBar scrThreshold 
      Height          =   255
      Left            =   1440
      TabIndex        =   6
      Top             =   4500
      Width           =   3615
   End
   Begin VB.HScrollBar scrSpotsize 
      Height          =   255
      Left            =   1440
      TabIndex        =   3
      Top             =   4020
      Width           =   3615
   End
   Begin VB.CommandButton cmdCompare 
      Caption         =   "Compare"
      Height          =   435
      Left            =   5160
      TabIndex        =   2
      Top             =   3960
      Width           =   1515
   End
   Begin VB.PictureBox picB 
      AutoRedraw      =   -1  'True
      DrawWidth       =   5
      Height          =   3735
      Left            =   5220
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   245
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   325
      TabIndex        =   0
      ToolTipText     =   "Linke Maustaste gedrckt halten um auf dem Bild zu malen !"
      Top             =   120
      Width           =   4935
   End
   Begin VB.PictureBox picA 
      AutoRedraw      =   -1  'True
      Height          =   3735
      Left            =   120
      Picture         =   "Form1.frx":2239
      ScaleHeight     =   245
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   325
      TabIndex        =   1
      Top             =   120
      Width           =   4935
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   $"Form1.frx":4472
      Height          =   1335
      Left            =   120
      TabIndex        =   9
      Top             =   4920
      Width           =   10095
   End
   Begin VB.Label lblThreshold 
      Caption         =   "Threshold:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   4500
      Width           =   1155
   End
   Begin VB.Label lblSpotsize 
      Caption         =   "Spotsize:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   4020
      Width           =   1155
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'************************************************************************
'*               Compare Bitmaps fast via asm with Threshold            *
'*                           by Daniel Aue 03.2004                      *
'*                                                                      *
'*                     USE ENTIRELY AT YOUR OWN RISK.                   *
'*                 you may publish this source as long as               *
'*                      this commentblock stays in                      *
'************************************************************************

Option Explicit

Dim bMouseHold As Boolean

Private Declare Function GetTickCount Lib "kernel32.dll" () As Long

Private Sub cmdBenchmark_Click()
   Dim Ticks As Long
   Dim fps As Long
   Dim X As Integer
   
   Me.MousePointer = vbHourglass
   Ticks = GetTickCount
   For X = 0 To 100
      DoASMCompare Me.picA.Picture, Me.picB.Picture, Me.scrSpotsize.Value, Me.scrThreshold.Value
   Next
   Ticks = GetTickCount - Ticks
   Me.MousePointer = vbDefault
   fps = 1000 / (Ticks / 100)
   MsgBox fps & " Frames per Second"
End Sub

Private Sub cmdClear_Click()
    Me.picB.Cls
End Sub

Private Sub cmdCompare_Click()
    Dim Percent As Double
    Form1.picB.DrawWidth = 1
    If optMarkChanges Then
        Percent = DoASMCompare(Me.picA.Image, Me.picB.Image, Me.scrSpotsize.Value, _
            Me.scrThreshold.Value, AddressOf CallbackFunc)
    ElseIf optMarkMatches Then
        Percent = DoASMCompare(Me.picA.Image, Me.picB.Image, Me.scrSpotsize.Value, _
            Me.scrThreshold.Value, AddressOf CallbackFunc, True)
    Else
        Percent = DoASMCompare(Me.picA.Image, Me.picB.Image, Me.scrSpotsize.Value, _
            Me.scrThreshold.Value)
    End If
   
    MsgBox Round(Percent, 2) & "%"
End Sub

Private Sub Form_Load()
    Me.scrSpotsize.Min = 1
    Me.scrSpotsize.Max = Me.picA.ScaleWidth
    Me.scrSpotsize.Value = 10
    
    Me.scrThreshold.Min = 0
    Me.scrThreshold.Max = 255
    Me.scrThreshold = 16
End Sub





Private Sub picB_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bMouseHold = True
    picB.DrawWidth = 5
    picB.PSet (X, Y)
End Sub


Private Sub picB_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If bMouseHold Then
        picB.PSet (X, Y)
    End If
End Sub

Private Sub picB_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bMouseHold = False
End Sub

Private Sub scrSpotsize_Change()
    Me.lblSpotsize = "Spotsize: " & Me.scrSpotsize.Value
    If Me.chkGrid Then
        DrawGrid
    End If
End Sub

Private Sub scrSpotsize_Scroll()
    scrSpotsize_Change
End Sub

Private Sub scrThreshold_Change()
    Me.lblThreshold = "Threshold: " & Hex(Me.scrThreshold.Value)
End Sub

Private Sub scrThreshold_Scroll()
    scrThreshold_Change
End Sub


Private Sub chkGrid_Click()
    If Me.chkGrid Then
        DrawGrid
        MsgBox "Der angezeigte Raster wird beim Vergleich " & _
            "gegebenenfalls als Unterschied ausgewertet. " & _
            "Das ist dann der Fall, wenn die weien Pixel " & _
            "des Rasters den Mittelwert eines Spots soweit " & _
            "'verndern', dass der Unterschied ber dem eingestellten " & _
            "Threshold liegt.", vbInformation, "Information:"
    Else
        Me.picB.Cls
    End If
End Sub


Private Sub DrawGrid()
    Dim X As Integer
    Dim Y As Integer
    
    Me.picB.Cls
    Me.picB.DrawWidth = 1
    'Grid geht von unten aus, da Bitmap upside down im Speicher liegt
    Y = Me.picB.ScaleHeight
    For X = 0 To Me.picB.ScaleWidth Step Me.scrSpotsize.Value
       picB.Line (X, 0)-(X, Me.picB.ScaleHeight), &HFFFFFF
       picB.Line (0, Y)-(Me.picB.ScaleWidth, Y), &HFFFFFF
       Y = Y - Me.scrSpotsize.Value
    Next
End Sub
